// HParaView.h : interface of the HParaView class, derived from HBaseView
// Adds application-specific data and members for each view

#ifndef _HPARAVIEW_H
#define _HPARAVIEW_H

#include "HBaseView.h"
#include "parasolid_kernel.h"
#include "kernel_interface.h"



class HParaView : public HBaseView
{

public:

	HParaView(HBaseModel *model,
        char * 		alias = null,	
        char *		driver_type = null,
		char *		instance_name = null,
        long		window_handle = 0,
        long		colormap = 0);

	long	m_parts_seg;
	long	m_construction_segment_key;

	void	Init();
	void	BooleanOperation(PK_boolean_function_t	operation);

};


#endif _HPARAVIEW_H