var NAVTREE =
[
  [ "3D Tutorial", "index.html", [
    [ "Related Pages", "pages.html", [
      [ "tutorial_3d-creating_3d_geometry", "tutorial_3d-creating_3d_geometry.html", null ],
      [ "tutorial_3d-loading_model", "tutorial_3d-loading_model.html", null ],
      [ "tutorial_3d-managing_3d_text", "tutorial_3d-managing_3d_text.html", null ],
      [ "tutorial_3d-manipulating_3d_geometry", "tutorial_3d-manipulating_3d_geometry.html", null ],
      [ "tutorial_3d-render_modes", "tutorial_3d-render_modes.html", null ],
      [ "tutorial_3d-setting_color_transparency", "tutorial_3d-setting_color_transparency.html", null ]
    ] ],
    [ "Class List", "annotated.html", [
      [ "CSpheresApp", "class_c_spheres_app.html", null ],
      [ "CSpheresDoc", "class_c_spheres_doc.html", null ],
      [ "CSpheresView", "class_c_spheres_view.html", null ],
      [ "HIOUtilitySpheres", "class_h_i_o_utility_spheres.html", null ],
      [ "HMyCreateSphere", "class_h_my_create_sphere.html", null ],
      [ "HSpheresModel", "class_h_spheres_model.html", null ],
      [ "HSpheresSelectionSet", "class_h_spheres_selection_set.html", null ],
      [ "HSpheresView", "class_h_spheres_view.html", null ]
    ] ],
    [ "Class Index", "classes.html", null ],
    [ "Class Hierarchy", "hierarchy.html", [
      [ "CHoopsApp", "../../../HoopsMFC/ref_manual/class_c_hoops_app.html", [
        [ "CSpheresApp", "class_c_spheres_app.html", null ]
      ] ],
      [ "CHoopsDoc", "../../../HoopsMFC/ref_manual/class_c_hoops_doc.html", [
        [ "CSpheresDoc", "class_c_spheres_doc.html", null ]
      ] ],
      [ "CHoopsView", "../../../HoopsMFC/ref_manual/class_c_hoops_view.html", [
        [ "CSpheresView", "class_c_spheres_view.html", null ]
      ] ],
      [ "HBaseModel", "../../../HoopsMVO/ref_manual/class_h_base_model.html", [
        [ "HSpheresModel", "class_h_spheres_model.html", null ]
      ] ],
      [ "HBaseView", "../../../HoopsMVO/ref_manual/class_h_base_view.html", [
        [ "HSpheresView", "class_h_spheres_view.html", null ]
      ] ],
      [ "HInputHandler", "../../../HoopsMVO/ref_manual/class_h_input_handler.html", [
        [ "HIOUtilitySpheres", "class_h_i_o_utility_spheres.html", null ]
      ] ],
      [ "HOpCreateSphere", "../../../HoopsMVO/ref_manual/class_h_op_create_sphere.html", [
        [ "HMyCreateSphere", "class_h_my_create_sphere.html", null ]
      ] ],
      [ "HOutputHandler", "../../../HoopsMVO/ref_manual/class_h_output_handler.html", [
        [ "HIOUtilitySpheres", "class_h_i_o_utility_spheres.html", null ]
      ] ],
      [ "HSelectionSet", "../../../HoopsMVO/ref_manual/class_h_selection_set.html", [
        [ "HSpheresSelectionSet", "class_h_spheres_selection_set.html", null ]
      ] ]
    ] ],
    [ "Class Members", "functions.html", null ],
    [ "Namespace List", "namespaces.html", [
      [ "com", "namespacecom.html", null ],
      [ "com::techsoft", "namespacecom_1_1techsoft.html", null ],
      [ "ezpdf", "namespaceezpdf.html", null ],
      [ "ezpdf::filters", "namespaceezpdf_1_1filters.html", null ],
      [ "HIOSkp", "namespace_h_i_o_skp.html", null ],
      [ "U3D_IDTF", "namespace_u3_d___i_d_t_f.html", null ]
    ] ],
    [ "File List", "files.html", [
      [ "HIOUtilitySpheres.h", "_h_i_o_utility_spheres_8h.html", null ],
      [ "HMyCreateSphere.h", "_h_my_create_sphere_8h.html", null ],
      [ "HSpheresModel.h", "_h_spheres_model_8h.html", null ],
      [ "HSpheresSelectionSet.h", "_h_spheres_selection_set_8h.html", null ],
      [ "HSpheresView.h", "_h_spheres_view_8h.html", null ],
      [ "Spheres.h", "_spheres_8h.html", null ],
      [ "SpheresDoc.h", "_spheres_doc_8h.html", null ],
      [ "SpheresView.h", "_spheres_view_8h.html", null ],
      [ "tutorial_3d-creating_3d_geometry.pre", "tutorial__3d-creating__3d__geometry_8pre.html", null ],
      [ "tutorial_3d-loading_model.pre", "tutorial__3d-loading__model_8pre.html", null ],
      [ "tutorial_3d-managing_3d_text.pre", "tutorial__3d-managing__3d__text_8pre.html", null ],
      [ "tutorial_3d-manipulating_3d_geometry.pre", "tutorial__3d-manipulating__3d__geometry_8pre.html", null ],
      [ "tutorial_3d-render_modes.pre", "tutorial__3d-render__modes_8pre.html", null ],
      [ "tutorial_3d-setting_color_transparency.pre", "tutorial__3d-setting__color__transparency_8pre.html", null ]
    ] ],
    [ "Directories", "dirs.html", [
      [ "demo", "dir_f287c6597746dc79f5b5363a5cde8c9c.html", [
        [ "tutorial", "dir_733ea46185650ec44d7f91aa63d4988d.html", [
          [ "spheres", "dir_f2f51c5afe5928bfd0233387452b2e9c.html", null ]
        ] ]
      ] ]
    ] ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

